#include "init_file_names.t"
#include "defines.t"      

file __INIT_CATALOG()
{

class catalog
{
  area sys;
  full_control root;
  full_control user;
  remove_old "name='root'";
  p name {val root;};

	p id_catalog_type {getByProp catalog_type {prop class_name{val catalog;};};};

	/* user with id=1 is system */
	p id_user {val 1;};
	/* use id=1, point to yourself */
	p id_item {val 1;};
	p id {val 1;};
};

class catalog
{
  area sys;
  full_control root;
  full_control user;
  full_control __PUBLIC__;
  
  remove_old "name='public_web'";
  p name {val public_web;};

	p id_catalog_type {getByProp catalog_type {prop class_name{val catalog;};};};

	/* user with id=1 is system */
	p id_user {val 1;};
	p id_item {current_id 1;};
	p id_parent {val 1;};
};

}; // end file catalog


file __INIT_MENU_CATALOG()
{

/* this is default menu that we can see on generic forms */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='default#single@catalog'";
  p name       {val		"default#single@catalog";};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		catalog;};
};

/*this is menu for left side on catalog form */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='left#catalog@catalog'";

  p name       {val		"left#catalog@catalog";};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		catalog;};
};

/* this is menu for right side on catalog form */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='right#catalog@catalog'";

  p name       {val		"right#catalog@catalog";};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		catalog;};
};

/* menu_attach! */
class js_code
{
   area sys;
   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = 'sys';

        // we read items data
        var meta = new class_meta_class(par_area);
        var cat = new class_catalog(par_area); 
	var rs =  cat.getItemData(context.active_item);
        var type_class_name = "attachment";

        // we take default form for items class
        var default_form = meta.getDefaultFormByName( -1, type_class_name);

        // we ask to open window with default form
        ap_write("open_url('/co/html/sys/" + type_class_name+"?" + default_form +
                 "&par_area="+ par_area +
                 "&par_class=catalog" +
                 "&par_id=" + context.active_item +
		 "&active_path=" + context.active_path +
                 "&debug_level=0');");
      %%
      ;
    };
};

class  menu_action
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='catalog_attach'";

   p name {val catalog_attach;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};

class menu_action_param
{
  area sys;
  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};

class menu_action_param
{
  area sys;
  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='attach' and class_name='catalog'";

  p name {val attach;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f "default#single@catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p display_name {val attach;};
  p menu_position {val 300; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val attach;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f "left#catalog@catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 300; };
};

/* end of attach */

}; // end file menu_catalog