

  /* TYPES  
  
    
    
    CO_INTEGER int 0
    
    
    CO_STRING char* 1
    
    
    CO_ARRAY_OF_STRINGS char** 1
    
    
    CO_STRING_SQL_VALUE char* 1
    
    
    CO_BOOL bool 0
    
    
    CO_DATE char* 1
    
    
    CO_REAL float 0
    
    
    CO_NUMERIC float 0
  
  */

  
  #include "httpd.h"
  
  /* PostgreSQL access functions */
  #include "libpq-fe.h"
  #include <stdlib.h>
  #include <unistd.h>
  
  #include "co_lib.h"
  #include "co_convutils.h"
  #include "co_defines.h"
  #include "co_generic_2d.h"
  
  #include "../generic_acl/co_generic_acl.h"

  static void exit_nicely(PGconn *conn) 
  {
  
  }
    
int co_check_acl2d 
               (co_context *cnx, co_typein_check_acl2d* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
              char *container_class;
      char *container_column_name;
      int container_id;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.check_acl2d parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.check_acl2d parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.check_acl2d parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.check_acl2d parameter not optionall: par_id2"); return(-1);};

      };	


__CREATE_QUERY("SELECT container_class, container_column_name FROM co_%s_meta_class WHERE class_name='%s'", par_area, par_class)
container_class = ap_pstrdup(p,PQgetvalue(res,0,0));
container_column_name = ap_pstrdup(p,PQgetvalue(res,0,1));
__SQL_GET_RESULT
__CLEAR_RESULT

__CREATE_QUERY("SELECT %s FROM co_%s_%s WHERE id1=%d AND id2=%d", container_column_name, par_area, par_class, par_id1, par_id2)
__SQL_GET_RESULT
container_id = atoi(PQgetresult(res,0,0));
__CLEAR_RESULT

	  
{
 co_typein_check_acl* out_param1;
out_param1=ap_palloc( r->pool, sizeof(co_typein_check_acl));
out_param1->par_class=container_class;
out_param1->par_area=par_area;
out_param1->callback="";
out_param1->par_id=container_id;
cou_broker(par_area,container_class,"check_acl",cnx,out_param1);
}
  return(0);      
} // end of method check_acl2d
      
      
int co_get2D 
               (co_context *cnx, co_typein_get2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
              char *container_class;
      char *container_column_name;
      int container_id;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char* callback ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          callback = struct_in->callback;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.get2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.get2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.get2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.get2D parameter not optionall: par_id2"); return(-1);};

	  callback = (char*)cou_getParam(cnx,"callback",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ callback=ap_psprintf(p,"alert(");; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.get2D parameter not optionall: callback"); return(-1);};

      };	


__INIT_VARIABLES
cou_sendMessageX(cnx, "entering get", CO_MSG_DEBUG);
__CREATE_QUERY("SELECT * FROM co_%s_%s WHERE id1=%d AND id2=%d" , par_area, par_class, par_id1, par_id2)
cou_sendMessageX(cnx, "get sql string:", CO_MSG_DEBUG);
cou_sendMessageX(cnx, SQLString, CO_MSG_DEBUG);
__GET_RESULT_AND_CREATE_JS
cou_sendMessageX(cnx, "leaving get", CO_MSG_DEBUG);
  return(0);      
} // end of method get2D
      
      
int co_getByProp2D 
               (co_context *cnx, co_typein_getByProp2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
              char *container_class;
      char *container_column_name;
      int container_id;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char* callback ;
       char* prop_name ;
       char* prop_val ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          callback = struct_in->callback;
          prop_name = struct_in->prop_name;
          prop_val = struct_in->prop_val;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getByProp2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getByProp2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getByProp2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getByProp2D parameter not optionall: par_id2"); return(-1);};

	  callback = (char*)cou_getParam(cnx,"callback",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ callback=ap_psprintf(p,"alert(");; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getByProp2D parameter not optionall: callback"); return(-1);};

	  prop_name = (char*)cou_getParam(cnx,"prop_name",CO_STRING, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getByProp2D parameter not optionall: prop_name"); return(-1);};

	  prop_val = (char*)cou_getParam(cnx,"prop_val",CO_STRING, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getByProp2D parameter not optionall: prop_val"); return(-1);};

      };	


cou_sendMessageX(cnx, ap_psprintf(p,"client_mode: %d", cnx->client_mode), CO_MSG_DEBUG);
__CREATE_QUERY("SELECT * FROM co_%s_%s WHERE %s='%s'" , par_area, par_class, prop_name, prop_val)
cou_sendMessageX(cnx, "getByProp sql string:", CO_MSG_DEBUG);
cou_sendMessageX(cnx, SQLString, CO_MSG_DEBUG);
__GET_RESULT_AND_CREATE_JS
  return(0);      
} // end of method getByProp2D
      
      
int co_update2D 
               (co_context *cnx, co_typein_update2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
              int cur_version;
      char *new_value_coded;
      char* puta_classes[2]={NULL,NULL};
      int puta_ids[2]={0,0};  


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char* par_prop ;
       char* new_value ;
       int version ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          par_prop = struct_in->par_prop;
          new_value = struct_in->new_value;
          version = struct_in->version;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.update2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.update2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.update2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.update2D parameter not optionall: par_id2"); return(-1);};

	  par_prop = (char*)cou_getParam(cnx,"par_prop",CO_STRING, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.update2D parameter not optionall: par_prop"); return(-1);};

	  new_value = (char*)cou_getParam(cnx,"new_value",CO_STRING, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.update2D parameter not optionall: new_value"); return(-1);};

	  { void *ret=cou_getParam(cnx,"version",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                version = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.update2D parameter not optionall: version"); return(-1);};

      };	


__INIT_VARIABLES

new_value_coded = cou_buildEncodedSQL(cnx, new_value);

__CREATE_QUERY("SELECT version FROM co_%s_%s WHERE id1=%d AND id2=%d",par_area, par_class, par_id1, par_id2)

__SQL_GET_RESULT
cur_version= atoi(PQgetvalue(res, 0, 0));
__CLEAR_RESULT
memset(SQLString, 0, SQLBUFSIZE);

if(version != cur_version) 
{
cou_sendMessage(cnx, "Nie poprawilismy danych bo miales stary obraz! (bez obrazy :-)");
return -1;
};

__CREATE_QUERY("UPDATE co_%s_%s SET %s=\'%s\', version=version+1 WHERE id1=%d AND id2=%d",
par_area, par_class, par_prop, new_value_coded, par_id1, par_id2)
__SQL_EXEC

puta_classes[0] = par_class;
puta_ids[0] = par_id;

cou_queueActionX( cnx, par_class, puta_classes, puta_ids, CO_OP_UPDATE, par_prop, new_value, NULL);
cou_queueActionX( cnx, par_class, puta_classes, puta_ids, CO_OP_UPDATE, "version",ap_psprintf(p,"%d",cur_version+1),NULL);
  return(0);      
} // end of method update2D
      
      
int co_insertChild2D 
               (co_context *cnx, co_typein_insertChild2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
                int new_id=0;
	int i;
	int nFields;
        char* puta_classes[3]={NULL,NULL,NULL};
	int puta_ids[3]={0,0,0};  
	char **props;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char* child_class ;
       char* child_prop ;
       char* foreign_prop ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          child_class = struct_in->child_class;
          child_prop = struct_in->child_prop;
          foreign_prop = struct_in->foreign_prop;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.insertChild2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.insertChild2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.insertChild2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.insertChild2D parameter not optionall: par_id2"); return(-1);};

	  child_class = (char*)cou_getParam(cnx,"child_class",CO_STRING, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.insertChild2D parameter not optionall: child_class"); return(-1);};

	  child_prop = (char*)cou_getParam(cnx,"child_prop",CO_STRING, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.insertChild2D parameter not optionall: child_prop"); return(-1);};

	  foreign_prop = (char*)cou_getParam(cnx,"foreign_prop",CO_STRING, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.insertChild2D parameter not optionall: foreign_prop"); return(-1);};

      };	


__INIT_VARIABLES
__CREATE_QUERY("INSERT INTO co_%s_%s (%s) SELECT %s FROM co_%s_%s WHERE id1=%d AND id2=%d",
par_area, child_class, child_prop, foreign_prop, par_area, par_class, par_id1, par_id2)

cou_sendMessageX(cnx, SQLString, CO_MSG_DEBUG);

__SQL_EXEC

__CREATE_QUERY("SELECT last_value FROM co_%s_%s_sqid", par_area, child_class)
__SQL_GET_RESULT
new_id= atoi(PQgetvalue(res, 0, 0));
__CLEAR_RESULT

cou_sendMessageX(cnx, "insertChild done", CO_MSG_DEBUG);

puta_classes[0] = par_class;
puta_ids[0] = par_id;

puta_classes[1] = child_class;
puta_ids[1] = new_id;

cou_queueActionX( cnx, par_class, puta_classes, puta_ids, CO_OP_INSERT, "child_class", child_class,NULL);



__CREATE_QUERY("SELECT * FROM co_%s_%s WHERE id = %d", par_area, child_class, new_id);

__SQL_GET_RESULT

puta_classes[0] = child_class;
puta_ids[0] = new_id;

puta_classes[1] = par_class;
puta_ids[1] = par_id;

puta_classes[2] = NULL;
puta_ids[2] = 0;

nFields = PQnfields(res);
props = ap_palloc(p, 2 * nFields * sizeof(char*) + 1);

for (i = 0; i < nFields; i++)
{
props[2*i] = ap_pstrdup(p, PQfname(res, i));
props[2*i+1] = ap_pstrdup(p, PQgetvalue(res, 0, i));
} 
props[2*i]=NULL;



__CLEAR_RESULT
cou_queueActionXX( cnx, child_class, puta_classes, puta_ids, CO_OP_UPDATE, props);
cou_setReturnValue(cnx, &new_id, CO_INTEGER);

  return(0);      
} // end of method insertChild2D
      
      
int co_select2D 
               (co_context *cnx, co_typein_select2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
               int get_col_num, filter_col_num;
       int sql_from_start,i;
       char column_value_coded[FIELDBUFSIZE];
       char column_value_js_encoded[FIELDBUFSIZE];


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char* callback ;
       char** get_class_names ;
       char** get_prop_names ;
       char** filter_class_names ;
       char** filter_prop_names ;
       char** filter_operators ;
       char** filter_values ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          callback = struct_in->callback;
          get_class_names = struct_in->get_class_names;
          get_prop_names = struct_in->get_prop_names;
          filter_class_names = struct_in->filter_class_names;
          filter_prop_names = struct_in->filter_prop_names;
          filter_operators = struct_in->filter_operators;
          filter_values = struct_in->filter_values;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: par_id2"); return(-1);};

	  callback = (char*)cou_getParam(cnx,"callback",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ callback=ap_psprintf(p,"alert(");; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: callback"); return(-1);};

	  get_class_names = (char**)cou_getParamArray(cnx,"_get_class_names",delim,MAXSELECTPAR, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: get_class_names"); return(-1);};

	  get_prop_names = (char**)cou_getParamArray(cnx,"_get_prop_names",delim,MAXSELECTPAR, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: get_prop_names"); return(-1);};

	  filter_class_names = (char**)cou_getParamArray(cnx,"_filter_class_names",delim,MAXSELECTPAR, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: filter_class_names"); return(-1);};

	  filter_prop_names = (char**)cou_getParamArray(cnx,"_filter_prop_names",delim,MAXSELECTPAR, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: filter_prop_names"); return(-1);};

	  filter_operators = (char**)cou_getParamArray(cnx,"_filter_operators",delim,MAXSELECTPAR, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: filter_operators"); return(-1);};

	  filter_values = (char**)cou_getParamArray(cnx,"_filter_values",delim,MAXSELECTPAR, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.select2D parameter not optionall: filter_values"); return(-1);};

      };	


__INIT_VARIABLES;

memset(column_value_coded,0,FIELDBUFSIZE);
memset(column_value_js_encoded,0,FIELDBUFSIZE);

snprintf(SQLString,SQLBUFSIZE, "SELECT ");

if(get_class_names[0])
{ 
sprintf(SQLString + strlen(SQLString), " co_%s_%s.%s ", par_area, get_class_names[0], get_prop_names[0]);
}
i=1;
while(get_class_names[i])
{
sprintf(SQLString + strlen(SQLString), " , co_%s_%s.%s ", par_area, get_class_names[i], get_prop_names[i]);
i++;
};

sql_from_start = strlen(SQLString);
sprintf(SQLString + strlen(SQLString), " FROM co_%s_%s ", par_area, get_class_names[0]);
i=1;
while(get_class_names[i])
{ 

if(0==strstr(SQLString+sql_from_start, get_class_names[i]))
{ 
sprintf(SQLString + strlen(SQLString), " , co_%s_%s ", par_area, get_class_names[i]);
};
i++;
};

sprintf(SQLString + strlen(SQLString), " WHERE co_%s_%s.%s %s \'%s\' ", par_area,
filter_class_names[0], filter_prop_names[0],filter_operators[0], filter_values[0]);
i=1;
while(filter_prop_names[i])
{
sprintf(SQLString + strlen(SQLString), " AND co_%s_%s.%s %s \'%s\' ",par_area,
filter_class_names[i], filter_prop_names[i],filter_operators[i], filter_values[i]);
i++;
};

cou_logError( cnx, CO_LOG_DEBUG, "SELECT SQL:");
cou_logError( cnx, CO_LOG_DEBUG, SQLString);

__GET_RESULT_AND_CREATE_JS
  return(0);      
} // end of method select2D
      
      
int co_getRelatedClasses2D 
               (co_context *cnx, co_typein_getRelatedClasses2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
               int get_col_num, filter_col_num;
       int sql_from_start,i;
       char column_value_coded[FIELDBUFSIZE];
       char column_value_js_encoded[FIELDBUFSIZE];


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char* callback ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          callback = struct_in->callback;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedClasses2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedClasses2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedClasses2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedClasses2D parameter not optionall: par_id2"); return(-1);};

	  callback = (char*)cou_getParam(cnx,"callback",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ callback=ap_psprintf(p,"alert(");; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedClasses2D parameter not optionall: callback"); return(-1);};

      };	


__INIT_VARIABLES
__CREATE_QUERY("SELECT class_name, prop_name, prop_foreign_prop FROM co_%s_meta_prop WHERE prop_foreign=\'%s\'", par_area, par_class);
__GET_RESULT_AND_CREATE_JS
  return(0);      
} // end of method getRelatedClasses2D
      
      
int co_getRelatedData2D 
               (co_context *cnx, co_typein_getRelatedData2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
               char * foreign_prop;
       char * foreign_val;
       char * rel_prop;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char* callback ;
       char* related_class ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          callback = struct_in->callback;
          related_class = struct_in->related_class;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedData2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedData2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedData2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedData2D parameter not optionall: par_id2"); return(-1);};

	  callback = (char*)cou_getParam(cnx,"callback",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ callback=ap_psprintf(p,"alert(");; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedData2D parameter not optionall: callback"); return(-1);};

	  related_class = (char*)cou_getParam(cnx,"related_class",CO_STRING, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getRelatedData2D parameter not optionall: related_class"); return(-1);};

      };	


__INIT_VARIABLES



__CREATE_QUERY("SELECT prop_name, prop_foreign_prop FROM co_%s_meta_prop WHERE prop_foreign='%s' and class_name='%s'",
par_area, par_class, related_class)
__SQL_GET_RESULT	    

if(PQntuples(res)>0)
{
rel_prop = ap_pstrdup(r->pool, PQgetvalue(res, 0, PQfnumber(res,"prop_name"))); 
foreign_prop = ap_pstrdup(r->pool, PQgetvalue(res, 0, PQfnumber(res,"prop_foreign_prop")));
}
else
{
cou_sendMessage(cnx, ap_psprintf(p, "GENERIC_2D::getRelatedData : could not find related prop for area:'%s' class:'%s' related_class:'%s'",
par_area,par_class, related_class));
return -1;
};

__CLEAR_RESULT


__CREATE_QUERY("SELECT %s FROM co_%s_%s WHERE id1=%d AND id2=%d", foreign_prop, par_area, par_class, par_id1, par_id2);

__SQL_GET_RESULT

if(PQntuples(res)>0)
{
foreign_val = ap_pstrdup(p, PQgetvalue(res, 0, 0)); 
}
else
{
cou_sendMessage(cnx, ap_psprintf(p, "GENERIC_2D::getRelatedData : could not find record for area:'%s' class:'%s' par_id1:%d par_id2:%d",
par_area,par_class, par_id1, par_id2));
return -1;
};

__CLEAR_RESULT


__CREATE_QUERY("SELECT * FROM co_%s_%s WHERE %s='%s'", par_area, related_class, rel_prop, foreign_val);

__GET_RESULT_AND_CREATE_JS
  return(0);      
} // end of method getRelatedData2D
      
      
int co_getSchema2D 
               (co_context *cnx, co_typein_getSchema2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
               char * foreign_prop;
       char * foreign_val;
       char * rel_prop;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char* callback ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          callback = struct_in->callback;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchema2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchema2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchema2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchema2D parameter not optionall: par_id2"); return(-1);};

	  callback = (char*)cou_getParam(cnx,"callback",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ callback=ap_psprintf(p,"alert(");; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchema2D parameter not optionall: callback"); return(-1);};

      };	


__INIT_VARIABLES
__CREATE_QUERY("SELECT * FROM co_%s_meta_prop WHERE class_name=\'%s\' ", par_area,par_class);
__GET_RESULT_AND_CREATE_JS
  return(0);      
} // end of method getSchema2D
      
      
int co_getWithSchema2D 
               (co_context *cnx, co_typein_getWithSchema2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
               char * foreign_prop;
       char * foreign_val;
       char * rel_prop;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char** callbacks ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          callbacks = struct_in->callbacks;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getWithSchema2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getWithSchema2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getWithSchema2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getWithSchema2D parameter not optionall: par_id2"); return(-1);};

	  callbacks = (char**)cou_getParamArray(cnx,"_callbacks",delim,MAXSELECTPAR, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getWithSchema2D parameter not optionall: callbacks"); return(-1);};

      };	


__INIT_VARIABLES
	  
{
 co_typein_getSchema* out_param2;
out_param2=ap_palloc( r->pool, sizeof(co_typein_getSchema));
out_param2->par_class=par_class;
out_param2->par_area=par_area;
out_param2->callback=callbacks[0];
out_param2->par_id=par_id;
cou_broker(par_area,par_class,"getSchema",cnx,out_param2);
}
	  
{
 co_typein_get* out_param3;
out_param3=ap_palloc( r->pool, sizeof(co_typein_get));
out_param3->par_class=par_class;
out_param3->par_area=par_area;
out_param3->callback=callbacks[1];
out_param3->par_id=par_id;
cou_broker(par_area,par_class,"get",cnx,out_param3);
}
  return(0);      
} // end of method getWithSchema2D
      
      
int co_getSchemaRelatedAndData2D 
               (co_context *cnx, co_typein_getSchemaRelatedAndData2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
               char * foreign_prop;
       char * foreign_val;
       char * rel_prop;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char** callbacks ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          callbacks = struct_in->callbacks;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchemaRelatedAndData2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchemaRelatedAndData2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchemaRelatedAndData2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchemaRelatedAndData2D parameter not optionall: par_id2"); return(-1);};

	  callbacks = (char**)cou_getParamArray(cnx,"_callbacks",delim,MAXSELECTPAR, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getSchemaRelatedAndData2D parameter not optionall: callbacks"); return(-1);};

      };	


__INIT_VARIABLES



	  
{
 co_typein_getSchema* out_param4;
out_param4=ap_palloc( r->pool, sizeof(co_typein_getSchema));
out_param4->par_class=par_class;
out_param4->par_area=par_area;
out_param4->callback=callbacks[0];
out_param4->par_id=par_id;
cou_broker(par_area,par_class,"getSchema",cnx,out_param4);
}
	  
{
 co_typein_getRelatedClasses* out_param5;
out_param5=ap_palloc( r->pool, sizeof(co_typein_getRelatedClasses));
out_param5->par_class=par_class;
out_param5->par_area=par_area;
out_param5->callback=callbacks[1];
out_param5->par_id=par_id;
cou_broker(par_area,par_class,"getRelatedClasses",cnx,out_param5);
}
	  
{
 co_typein_get* out_param6;
out_param6=ap_palloc( r->pool, sizeof(co_typein_get));
out_param6->par_class=par_class;
out_param6->par_area=par_area;
out_param6->callback=callbacks[2];
out_param6->par_id=par_id;
cou_broker(par_area,par_class,"get",cnx,out_param6);
}
  return(0);      
} // end of method getSchemaRelatedAndData2D
      
      
int co_getForRelatedSchemaAndData2D 
               (co_context *cnx, co_typein_getForRelatedSchemaAndData2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
               char * foreign_prop;
       char * foreign_val;
       char * rel_prop;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
       char* related_class ;
       char** callbacks ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
          related_class = struct_in->related_class;
          callbacks = struct_in->callbacks;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getForRelatedSchemaAndData2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getForRelatedSchemaAndData2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getForRelatedSchemaAndData2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getForRelatedSchemaAndData2D parameter not optionall: par_id2"); return(-1);};

	  related_class = (char*)cou_getParam(cnx,"related_class",CO_STRING, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getForRelatedSchemaAndData2D parameter not optionall: related_class"); return(-1);};

	  callbacks = (char**)cou_getParamArray(cnx,"_callbacks",delim,MAXSELECTPAR, &err);
if(err<0) {cou_sendMessage(cnx,"in generic_2d.getForRelatedSchemaAndData2D parameter not optionall: callbacks"); return(-1);};

      };	


__INIT_VARIABLES



	  
{
 co_typein_getSchema* out_param7;
out_param7=ap_palloc( r->pool, sizeof(co_typein_getSchema));
out_param7->par_class=related_class;
out_param7->par_area=par_area;
out_param7->callback=callbacks[0];
out_param7->par_id=par_id;
cou_broker(par_area,related_class,"getSchema",cnx,out_param7);
}
	  
{
 co_typein_getRelatedData* out_param8;
out_param8=ap_palloc( r->pool, sizeof(co_typein_getRelatedData));
out_param8->par_class=par_class;
out_param8->par_area=par_area;
out_param8->callback=callbacks[1];
out_param8->related_class=related_class;
out_param8->par_id=par_id;
cou_broker(par_area,par_class,"getRelatedData",cnx,out_param8);
}
  return(0);      
} // end of method getForRelatedSchemaAndData2D
      
      
int co_showForm2D 
               (co_context *cnx, co_typein_showForm2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
        	FILE *fh;
	int c;
	const char* root_path;
        long len;
        int user_id=1;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.showForm2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.showForm2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.showForm2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.showForm2D parameter not optionall: par_id2"); return(-1);};

      };	


root_path = cou_getCORootPath( cnx );
fh = ap_pfopen(p, ap_pstrcat( p, root_path, "/forms/", "generic", "_head.html", NULL), "r");
if (!fh) cou_error( cnx, "Head file not found");
cou_logError( cnx, CO_LOG_DEBUG, "sending head" );
ap_rputs("<HEAD>\n", r);
ap_kill_timeout(r);
len = ap_send_fd( fh, r );  
ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "Head sent: %d bytes", len);
ap_pfclose(p,fh);
cou_logError( cnx, CO_LOG_DEBUG, "sending script" );
ap_rputs("<SCRIPT>\n", r);

ap_rprintf( r, "var  id_session = %d;\n", cou_assignNewSession( cnx ) );
ap_rprintf( r, "var  par_id = %d;\n", par_id );
ap_rprintf( r, "var  par_class=\'%s\';\n", par_class );
ap_rprintf( r, "var  par_area = \'%s\';\n", par_area );
ap_rprintf( r, "var  debug_level = %d;\n", cnx->debug_level );

ap_rputs("</SCRIPT>\n", r);

ap_rputs("</HEAD>\n", r);
fh = ap_pfopen(p, ap_pstrcat( p, root_path, "/forms/", "generic", "_body.html", NULL), "r");
if (!fh) cou_error( cnx, "Body file not found");
cou_logError( cnx, CO_LOG_DEBUG, "sending body" );
ap_rputs("<BODY>\n", r);
len = ap_send_fd( fh, r );  

if (r->connection->aborted) ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "connection aborted");
ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "bytes_send=%d", r->bytes_sent);

ap_soft_timeout("finish request", r);

ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "Body sent: %d bytes", len);

ap_pfclose(p,fh);
ap_rputs("</BODY>\n", r);

ap_rflush(r);
  return(0);      
} // end of method showForm2D
      
      
int co_showFormFind2D 
               (co_context *cnx, co_typein_showFormFind2D* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err;
       int return_int;
       char *return_str;
       char *delim = "=";
       char *get_str;
       
      // local declarations of variables
        	FILE *fh;
	int c;
	const char* root_path;
	long len;
	int user_id;


       
      // definitions for input params 
       char* par_area ;
       char* par_class ;
       int par_id1 ;
       int par_id2 ;
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
          par_area = struct_in->par_area;
          par_class = struct_in->par_class;
          par_id1 = struct_in->par_id1;
          par_id2 = struct_in->par_id2;
      }
      else
      {	
      //input params are in request string
	  par_area = (char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.showFormFind2D parameter not optionall: par_area"); return(-1);};

	  par_class = (char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.showFormFind2D parameter not optionall: par_class"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id1",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id1 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.showFormFind2D parameter not optionall: par_id1"); return(-1);};

	  { void *ret=cou_getParam(cnx,"par_id2",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id2 = *(int *)ret;
	      }
	    }
if(err<0) {cou_sendMessage(cnx,"in generic_2d.showFormFind2D parameter not optionall: par_id2"); return(-1);};

      };	


user_id = cnx->user_id;
root_path = cou_getCORootPath( cnx );

fh = ap_pfopen(r->pool, ap_pstrcat( p, root_path, "/forms/", "generic_f", "_head.html", NULL), "r");
if (!fh) cou_error( cnx, "Head file not found");
cou_logError( cnx, CO_LOG_DEBUG, "sending head" );
ap_rputs("<HEAD>\n", r);
ap_kill_timeout(r);

len = ap_send_fd( fh, r );  
ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "Head sent: %d bytes", len);

ap_pfclose(p,fh);

cou_logError( cnx, CO_LOG_DEBUG, "sending script" );
ap_rputs("<SCRIPT>\n", r);

ap_rprintf( r, "var  id_session = %d;\n", cou_assignNewSession( cnx ) );
ap_rprintf( r, "var  par_id = %d;\n", par_id );
ap_rprintf( r, "var  par_class=\'%s\';\n", par_class );
ap_rprintf( r, "var  par_area = \'%s\';\n", par_area );
ap_rprintf( r, "var  debug_level = %d;\n", cnx->debug_level );

ap_rputs("</SCRIPT>\n", r);

ap_rputs("</HEAD>\n", r);
fh = ap_pfopen(p, ap_pstrcat( p, root_path, "/forms/", "generic_f", "_body.html", NULL), "r");
if (!fh) cou_error( cnx, "Body file not found");
cou_logError( cnx, CO_LOG_DEBUG, "sending body" );
ap_rputs("<BODY>\n", r);
len = ap_send_fd( fh, r );  

if (r->connection->aborted) ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "connection aborted");
ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "bytes_send=%d", r->bytes_sent);

ap_soft_timeout("finish request", r);

ap_log_rerror(APLOG_MARK, APLOG_DEBUG, r, "Body sent: %d bytes", len);

ap_pfclose(p,fh);
ap_rputs("</BODY>\n", r);

ap_rflush(r);
  return(0);      
} // end of method showFormFind2D
      
      
      
     // end of class 
     
