
  #include "httpd.h"
  
  /* PostgreSQL access functions */
  #include "libpq-fe.h"
  #include <stdlib.h>
  #include <unistd.h>
  
  #include "co_lib.h"
  #include "co_convutils.h"
  #include "../coffice/co_recordset.h"
  #include "../coffice/co_array.h"
  #include "../coffice/co_string.h"
  #include "co_defines.h"
  #include "co_defines_calls.h"
  #include "co_generic_association.h"
   #include "../generic/co_generic.h" 
#include "../coffice/mod_coffice.h" 
static void exit_nicely(PGconn *conn) { } 

#undef  __METHOD__
#define __METHOD__ "showFormAssociation"
int co_showFormAssociation 
               (co_context *cnx, co_typein_showFormAssociation* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char MESGString[MESGSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err=0;
       int dirty_res = 0;
       int return_int;
       const char *return_str;
       const char *delim = "=";
       const char *get_str;
       co_recordset *corec;
// local declarations of variables 
 const char* filename;
const char* root_path;
const char* prop_foreign1;
const char* prop_foreign2;
// definitions for input params 
const char* par_area; 
const char* par_class; 
int par_id; 
const char* column_first_class; 
const char* report_first_class; 
const char* column_second_class; 
const char* report_second_class; 

      // first initialization of variables
      __INIT_VARIABLES
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in

         if(struct_in->control->par_area == 1)
          {
             __PARAM_STRUCT_READ(par_area,struct_in,par_area);
          }
          else
          {
par_area=cnx->par_area;; 

          } 
 
         if(struct_in->control->par_class == 1)
          {
             __PARAM_STRUCT_READ(par_class,struct_in,par_class);
          }
          else
          {
par_class=cnx->par_class;; 

          } 
 
         if(struct_in->control->par_id == 1)
          {
             __PARAM_STRUCT_READ(par_id,struct_in,par_id);
          }
          else
          {
 __ASSERT(0, "Parameter par_id not set and does not have default"); 

          } 
 
         if(struct_in->control->column_first_class == 1)
          {
             __PARAM_STRUCT_READ(column_first_class,struct_in,column_first_class);
          }
          else
          {
column_first_class=NULL; 

          } 
 
         if(struct_in->control->report_first_class == 1)
          {
             __PARAM_STRUCT_READ(report_first_class,struct_in,report_first_class);
          }
          else
          {
report_first_class=NULL; 

          } 
 
         if(struct_in->control->column_second_class == 1)
          {
             __PARAM_STRUCT_READ(column_second_class,struct_in,column_second_class);
          }
          else
          {
column_second_class=NULL; 

          } 
 
         if(struct_in->control->report_second_class == 1)
          {
             __PARAM_STRUCT_READ(report_second_class,struct_in,report_second_class);
          }
          else
          {
report_second_class=NULL; 

          } 
 
      }
      else
      {	
      //input params are in request string
par_area = (const char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
__ASSERT(err>=0, "in generic_association.showFormAssociation parameter not optional: par_area")

par_class = (const char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
__ASSERT(err>=0, "in generic_association.showFormAssociation parameter not optional: par_class")

{ void *ret=cou_getParam(cnx,"par_id",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id = *(int *)ret;
	      }
	      else
	      {
                par_id = (int)0;
	      }
	    }
__ASSERT(err>=0, "in generic_association.showFormAssociation parameter not optional: par_id")

column_first_class = (const char*)cou_getParam(cnx,"column_first_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ column_first_class=NULL; err=0; }
__ASSERT(err>=0, "in generic_association.showFormAssociation parameter not optional: column_first_class")

report_first_class = (const char*)cou_getParam(cnx,"report_first_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ report_first_class=NULL; err=0; }
__ASSERT(err>=0, "in generic_association.showFormAssociation parameter not optional: report_first_class")

column_second_class = (const char*)cou_getParam(cnx,"column_second_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ column_second_class=NULL; err=0; }
__ASSERT(err>=0, "in generic_association.showFormAssociation parameter not optional: column_second_class")

report_second_class = (const char*)cou_getParam(cnx,"report_second_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ report_second_class=NULL; err=0; }
__ASSERT(err>=0, "in generic_association.showFormAssociation parameter not optional: report_second_class")

       } 
 
__SQL_GET_STRING( prop_foreign1, "SELECT prop_foreign FROM co_%s_meta_prop WHERE
class_name='%s' and prop_name='%s'", par_area, par_class, column_first_class)

__SQL_GET_STRING( prop_foreign2, "SELECT prop_foreign FROM co_%s_meta_prop WHERE
class_name='%s' and prop_name='%s'", par_area, par_class, column_second_class)

//cou_putsHTML("<FRAMESET rows=\"50,50%,*\">");			
root_path = cou_getCORootPath( cnx );
filename = ap_psprintf(p, "%s/generic_association/showFormAssociation.asp", root_path);
__PUT_ASP_FROM_FILE(filename)
    
  if (dirty_res)
	cou_logError( cnx, CO_LOG_DEBUG, "generic_association::showFormAssociation has dirty res");

  return(0);
} // end of method showFormAssociation

#undef  __METHOD__
#define __METHOD__ "showFormMenu"
int co_showFormMenu 
               (co_context *cnx, co_typein_showFormMenu* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char MESGString[MESGSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err=0;
       int dirty_res = 0;
       int return_int;
       const char *return_str;
       const char *delim = "=";
       const char *get_str;
       co_recordset *corec;
// local declarations of variables 
 const char* filename;
const char* root_path;
// definitions for input params 
const char* par_area; 
const char* par_class; 
int par_id; 
const char* menu_name; 
const char* menu_type; 

      // first initialization of variables
      __INIT_VARIABLES
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in

         if(struct_in->control->par_area == 1)
          {
             __PARAM_STRUCT_READ(par_area,struct_in,par_area);
          }
          else
          {
par_area=cnx->par_area;; 

          } 
 
         if(struct_in->control->par_class == 1)
          {
             __PARAM_STRUCT_READ(par_class,struct_in,par_class);
          }
          else
          {
par_class=cnx->par_class;; 

          } 
 
         if(struct_in->control->par_id == 1)
          {
             __PARAM_STRUCT_READ(par_id,struct_in,par_id);
          }
          else
          {
 __ASSERT(0, "Parameter par_id not set and does not have default"); 

          } 
 
         if(struct_in->control->menu_name == 1)
          {
             __PARAM_STRUCT_READ(menu_name,struct_in,menu_name);
          }
          else
          {
menu_name="default"; 

          } 
 
         if(struct_in->control->menu_type == 1)
          {
             __PARAM_STRUCT_READ(menu_type,struct_in,menu_type);
          }
          else
          {
menu_type="multi"; 

          } 
 
      }
      else
      {	
      //input params are in request string
par_area = (const char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
__ASSERT(err>=0, "in generic_association.showFormMenu parameter not optional: par_area")

par_class = (const char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
__ASSERT(err>=0, "in generic_association.showFormMenu parameter not optional: par_class")

{ void *ret=cou_getParam(cnx,"par_id",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id = *(int *)ret;
	      }
	      else
	      {
                par_id = (int)0;
	      }
	    }
__ASSERT(err>=0, "in generic_association.showFormMenu parameter not optional: par_id")

menu_name = (const char*)cou_getParam(cnx,"menu_name",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ menu_name="default"; err=0; }
__ASSERT(err>=0, "in generic_association.showFormMenu parameter not optional: menu_name")

menu_type = (const char*)cou_getParam(cnx,"menu_type",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ menu_type="multi"; err=0; }
__ASSERT(err>=0, "in generic_association.showFormMenu parameter not optional: menu_type")

       } 
 
root_path = cou_getCORootPath( cnx );
filename = ap_psprintf(p, "%s/menu/showMenu.asp", root_path);
__PUT_ASP_FROM_FILE(filename)

    
  if (dirty_res)
	cou_logError( cnx, CO_LOG_DEBUG, "generic_association::showFormMenu has dirty res");

  return(0);
} // end of method showFormMenu

#undef  __METHOD__
#define __METHOD__ "insertAssociations"
int co_insertAssociations 
               (co_context *cnx, co_typein_insertAssociations* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char MESGString[MESGSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err=0;
       int dirty_res = 0;
       int return_int;
       const char *return_str;
       const char *delim = "=";
       const char *get_str;
       co_recordset *corec;
// local declarations of variables 
 int NIds1=0, NIds2=0;
int i,j;
int id_new;
const char *str_id1, *str_id2;
co_array_of_pointers * create_params;
co_recordset * inserted_corec;
// definitions for input params 
const char* par_area; 
const char* par_class; 
int par_id; 
const char* callback; 
co_array_of_pointers * ids_first_class; 
const char* prop_first_class; 
co_array_of_pointers * ids_second_class; 
const char* prop_second_class; 

      // first initialization of variables
      __INIT_VARIABLES
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in

         if(struct_in->control->par_area == 1)
          {
             __PARAM_STRUCT_READ(par_area,struct_in,par_area);
          }
          else
          {
par_area=cnx->par_area;; 

          } 
 
         if(struct_in->control->par_class == 1)
          {
             __PARAM_STRUCT_READ(par_class,struct_in,par_class);
          }
          else
          {
par_class=cnx->par_class;; 

          } 
 
         if(struct_in->control->par_id == 1)
          {
             __PARAM_STRUCT_READ(par_id,struct_in,par_id);
          }
          else
          {
 __ASSERT(0, "Parameter par_id not set and does not have default"); 

          } 
 
         if(struct_in->control->callback == 1)
          {
             __PARAM_STRUCT_READ(callback,struct_in,callback);
          }
          else
          {
callback=ap_pstrdup(p,"");; 

          } 
 
         if(struct_in->control->ids_first_class == 1)
          {
             __PARAM_STRUCT_READ(ids_first_class,struct_in,ids_first_class);
          }
          else
          {
ids_first_class=NULL; 

          } 
 
         if(struct_in->control->prop_first_class == 1)
          {
             __PARAM_STRUCT_READ(prop_first_class,struct_in,prop_first_class);
          }
          else
          {
prop_first_class=NULL; 

          } 
 
         if(struct_in->control->ids_second_class == 1)
          {
             __PARAM_STRUCT_READ(ids_second_class,struct_in,ids_second_class);
          }
          else
          {
ids_second_class=NULL; 

          } 
 
         if(struct_in->control->prop_second_class == 1)
          {
             __PARAM_STRUCT_READ(prop_second_class,struct_in,prop_second_class);
          }
          else
          {
prop_second_class=NULL; 

          } 
 
      }
      else
      {	
      //input params are in request string
par_area = (const char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
__ASSERT(err>=0, "in generic_association.insertAssociations parameter not optional: par_area")

par_class = (const char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
__ASSERT(err>=0, "in generic_association.insertAssociations parameter not optional: par_class")

{ void *ret=cou_getParam(cnx,"par_id",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id = *(int *)ret;
	      }
	      else
	      {
                par_id = (int)0;
	      }
	    }
__ASSERT(err>=0, "in generic_association.insertAssociations parameter not optional: par_id")

callback = (const char*)cou_getParam(cnx,"callback",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ callback=ap_pstrdup(p,"");; err=0; }
__ASSERT(err>=0, "in generic_association.insertAssociations parameter not optional: callback")

ids_first_class = (co_array_of_pointers *)cou_getParamArray(cnx,"_ids_first_class",delim,MAXSELECTPAR, &err);
if(err==CO_PARAMETER_NOT_FOUND){ ids_first_class=NULL; err=0; }
__ASSERT(err>=0, "in generic_association.insertAssociations parameter not optional: ids_first_class")

prop_first_class = (const char*)cou_getParam(cnx,"prop_first_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ prop_first_class=NULL; err=0; }
__ASSERT(err>=0, "in generic_association.insertAssociations parameter not optional: prop_first_class")

ids_second_class = (co_array_of_pointers *)cou_getParamArray(cnx,"_ids_second_class",delim,MAXSELECTPAR, &err);
if(err==CO_PARAMETER_NOT_FOUND){ ids_second_class=NULL; err=0; }
__ASSERT(err>=0, "in generic_association.insertAssociations parameter not optional: ids_second_class")

prop_second_class = (const char*)cou_getParam(cnx,"prop_second_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ prop_second_class=NULL; err=0; }
__ASSERT(err>=0, "in generic_association.insertAssociations parameter not optional: prop_second_class")

       } 
 inserted_corec = cor_CreateEmpty(cnx);
NIds1 = coa_GetElementCount(cnx, ids_first_class);
NIds2 = coa_GetElementCount(cnx, ids_second_class);
for(i=0; i<NIds1; i++)
{
str_id1 = coa_GetStringElement(cnx, ids_first_class, i);
for(j=0; j<NIds2; j++)
{
str_id2 = coa_GetStringElement(cnx, ids_second_class, j);
// create new record, then select it and add to result
create_params = coa_Create( cnx );
coa_AppendElement( cnx, create_params, prop_first_class);
coa_AppendElement( cnx, create_params, str_id1);
coa_AppendElement( cnx, create_params, prop_second_class);
coa_AppendElement( cnx, create_params, str_id2);
{  
             __PARAM_STRUCT_CREATE_createAndSet(out_param1)
            co_client_mode old_client_mode = cnx->client_mode;
            cnx->client_mode=CO_CLIENT_NO_MODE;
  __PARAM_STRUCT_SET(par_class , out_param1, par_class)
__PARAM_STRUCT_SET(par_area , out_param1, par_area)
__PARAM_STRUCT_SET("" , out_param1, callback)
__PARAM_STRUCT_SET(create_params , out_param1, create_params)
__PARAM_STRUCT_SET(par_id , out_param1, par_id)
cou_broker(par_area,par_class,"createAndSet",cnx,out_param1);
cnx->client_mode = old_client_mode;
}
__GET_RETURNED_INTEGER(id_new);
__CREATE_QUERY("SELECT * FROM co_%s_%s WHERE id=%d", 
par_area, par_class, id_new)
__SQL_GET_RESULT
cor_AppendRecordset(cnx, inserted_corec, corec);
__CLEAR_RESULT
}
}
__CREATE_JS_FROM(inserted_corec)
__RETURN_RECORDSET(inserted_corec)
    
  if (dirty_res)
	cou_logError( cnx, CO_LOG_DEBUG, "generic_association::insertAssociations has dirty res");

  return(0);
} // end of method insertAssociations
 
#undef  __METHOD__
#define __METHOD__ "pbs_showFormAssociation"

co_typein_showFormAssociation*  
   pbs_showFormAssociation 
   (
     co_context *cnx
   )
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       __PARAM_STRUCT_CREATE_showFormAssociation(param_struct)
       int err;
       const char *delim = "=";
       char MESGString[MESGSIZE];

       
      // definitions for input params 
const char* par_area; 
const char* par_class; 
int par_id; 
const char* column_first_class; 
const char* report_first_class; 
const char* column_second_class; 
const char* report_second_class; 
//input params are in request string 
par_area = (const char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormAssociation parameter not optional: par_area")

par_class = (const char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormAssociation parameter not optional: par_class")

{ void *ret=cou_getParam(cnx,"par_id",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id = *(int *)ret;
	      }
	      else
	      {
                par_id = (int)0;
	      }
	    }
__ASSERT_NULL(err>=0, "in generic_association.showFormAssociation parameter not optional: par_id")

column_first_class = (const char*)cou_getParam(cnx,"column_first_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ column_first_class=NULL; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormAssociation parameter not optional: column_first_class")

report_first_class = (const char*)cou_getParam(cnx,"report_first_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ report_first_class=NULL; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormAssociation parameter not optional: report_first_class")

column_second_class = (const char*)cou_getParam(cnx,"column_second_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ column_second_class=NULL; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormAssociation parameter not optional: column_second_class")

report_second_class = (const char*)cou_getParam(cnx,"report_second_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ report_second_class=NULL; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormAssociation parameter not optional: report_second_class")

// assigning params to struct 
__PARAM_STRUCT_SET(par_area, param_struct , par_area) 
__PARAM_STRUCT_SET(par_class, param_struct , par_class) 
__PARAM_STRUCT_SET(par_id, param_struct , par_id) 
__PARAM_STRUCT_SET(column_first_class, param_struct , column_first_class) 
__PARAM_STRUCT_SET(report_first_class, param_struct , report_first_class) 
__PARAM_STRUCT_SET(column_second_class, param_struct , column_second_class) 
__PARAM_STRUCT_SET(report_second_class, param_struct , report_second_class) 

  return(param_struct);      

} // end of pbs method showFormAssociation
 
#undef  __METHOD__
#define __METHOD__ "pbs_showFormMenu"

co_typein_showFormMenu*  
   pbs_showFormMenu 
   (
     co_context *cnx
   )
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       __PARAM_STRUCT_CREATE_showFormMenu(param_struct)
       int err;
       const char *delim = "=";
       char MESGString[MESGSIZE];

       
      // definitions for input params 
const char* par_area; 
const char* par_class; 
int par_id; 
const char* menu_name; 
const char* menu_type; 
//input params are in request string 
par_area = (const char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormMenu parameter not optional: par_area")

par_class = (const char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormMenu parameter not optional: par_class")

{ void *ret=cou_getParam(cnx,"par_id",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id = *(int *)ret;
	      }
	      else
	      {
                par_id = (int)0;
	      }
	    }
__ASSERT_NULL(err>=0, "in generic_association.showFormMenu parameter not optional: par_id")

menu_name = (const char*)cou_getParam(cnx,"menu_name",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ menu_name="default"; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormMenu parameter not optional: menu_name")

menu_type = (const char*)cou_getParam(cnx,"menu_type",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ menu_type="multi"; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.showFormMenu parameter not optional: menu_type")

// assigning params to struct 
__PARAM_STRUCT_SET(par_area, param_struct , par_area) 
__PARAM_STRUCT_SET(par_class, param_struct , par_class) 
__PARAM_STRUCT_SET(par_id, param_struct , par_id) 
__PARAM_STRUCT_SET(menu_name, param_struct , menu_name) 
__PARAM_STRUCT_SET(menu_type, param_struct , menu_type) 

  return(param_struct);      

} // end of pbs method showFormMenu
 
#undef  __METHOD__
#define __METHOD__ "pbs_insertAssociations"

co_typein_insertAssociations*  
   pbs_insertAssociations 
   (
     co_context *cnx
   )
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       __PARAM_STRUCT_CREATE_insertAssociations(param_struct)
       int err;
       const char *delim = "=";
       char MESGString[MESGSIZE];

       
      // definitions for input params 
const char* par_area; 
const char* par_class; 
int par_id; 
const char* callback; 
co_array_of_pointers * ids_first_class; 
const char* prop_first_class; 
co_array_of_pointers * ids_second_class; 
const char* prop_second_class; 
//input params are in request string 
par_area = (const char*)cou_getParam(cnx,"par_area",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_area=cnx->par_area;; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.insertAssociations parameter not optional: par_area")

par_class = (const char*)cou_getParam(cnx,"par_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ par_class=cnx->par_class;; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.insertAssociations parameter not optional: par_class")

{ void *ret=cou_getParam(cnx,"par_id",CO_INTEGER, &err);
              if(ret != NULL)
	      {
                par_id = *(int *)ret;
	      }
	      else
	      {
                par_id = (int)0;
	      }
	    }
__ASSERT_NULL(err>=0, "in generic_association.insertAssociations parameter not optional: par_id")

callback = (const char*)cou_getParam(cnx,"callback",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ callback=ap_pstrdup(p,"");; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.insertAssociations parameter not optional: callback")

ids_first_class = (co_array_of_pointers *)cou_getParamArray(cnx,"_ids_first_class",delim,MAXSELECTPAR, &err);
if(err==CO_PARAMETER_NOT_FOUND){ ids_first_class=NULL; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.insertAssociations parameter not optional: ids_first_class")

prop_first_class = (const char*)cou_getParam(cnx,"prop_first_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ prop_first_class=NULL; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.insertAssociations parameter not optional: prop_first_class")

ids_second_class = (co_array_of_pointers *)cou_getParamArray(cnx,"_ids_second_class",delim,MAXSELECTPAR, &err);
if(err==CO_PARAMETER_NOT_FOUND){ ids_second_class=NULL; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.insertAssociations parameter not optional: ids_second_class")

prop_second_class = (const char*)cou_getParam(cnx,"prop_second_class",CO_STRING, &err);
if(err==CO_PARAMETER_NOT_FOUND){ prop_second_class=NULL; err=0; }
__ASSERT_NULL(err>=0, "in generic_association.insertAssociations parameter not optional: prop_second_class")

// assigning params to struct 
__PARAM_STRUCT_SET(par_area, param_struct , par_area) 
__PARAM_STRUCT_SET(par_class, param_struct , par_class) 
__PARAM_STRUCT_SET(par_id, param_struct , par_id) 
__PARAM_STRUCT_SET(callback, param_struct , callback) 
__PARAM_STRUCT_SET(ids_first_class, param_struct , ids_first_class) 
__PARAM_STRUCT_SET(prop_first_class, param_struct , prop_first_class) 
__PARAM_STRUCT_SET(ids_second_class, param_struct , ids_second_class) 
__PARAM_STRUCT_SET(prop_second_class, param_struct , prop_second_class) 

  return(param_struct);      

} // end of pbs method insertAssociations
// end of class generic_association 
