/* this will be mod_co_spreadsheet */

#include "httpd.h"

/* PostgreSQL access functions */
#include "libpq-fe.h"
#include <stdlib.h>
#include <unistd.h>

#include "../../include/co_lib.h"
#include "../../include/co_convutils.h"
#include "../../include/co_defines.h"

static void
exit_nicely(PGconn *conn)
{
}

__CO_METHOD(co_get)

 __GET_INTEGER(par_id)

 int cols = column_number(conn,par_id);
 int rows = row_number(conn,par_id);
 int i,j,pos;
 
 __INIT_VARIABLES
 
 sprintf(SQLString,"SELECT C.column_number,R.row_number,CL.value FROM ");
 sprintf(SQLString,"%sco_sys_spreadsheet_columns C, co_sys_spreadsheet_rows R, co_sys_spreadsheet_cells CL ",SQLString);
 sprintf(SQLString,"%sWHERE C.spreadsheet_id=%d AND C.spreadsheet_id=R.spreadsheet_id AND ",SQLString,par_id);
 sprintf(SQLString,"%sC.id=CL.column_id AND R.id=CL.row_id ",SQLString);
 sprintf(SQLString,"%sORDER BY R.row_number ASC, C.column_number ASC",SQLString);

 __SQL_GET_RESULT

 //ap_rprintf(r,"wir haben %d tuples!!!<BR>",PQntuples(res));

 ap_rputs("<TABLE bordercolor=black >",r);

 ap_rputs("<TR><TD bgcolor=black></TD>",r);
 for (i=1; i <= cols; i++) ap_rprintf(r,"<TD bgcolor=yellow ALIGN=center><B>%d</B></TD>",i);
 ap_rputs("</TR>",r);

 pos = 0;
 for (i=1; i <= rows; i++)
 {
  ap_rprintf(r,"<TR><TD bgcolor=lightblue><B>%d</B></TD>",i);
  for (j=1; j <= cols; j++)  
  {
   if (pos==PQntuples(res)) sprintf(JSOutBuf,".");
   else sprintf(JSOutBuf,((i==atoi(PQgetvalue(res,pos,1))) && (j==atoi(PQgetvalue(res,pos,0)))) ? ((char *) PQgetvalue(res,pos++,2)) : ".");
   ap_rprintf(r,"<TD>%s</TD>",JSOutBuf);
  }
  ap_rputs("</TR>",r);
 }
 
 PQclear(res);
 
 ap_rputs("</TABLE>",r);

 return 0;
}

__CO_METHOD(co_edit)

 __GET_INTEGER(par_id)

 ap_rputs("<FRAMESET ROWS='120,*' FRAMEBORDER=NO FRAMESPACING=0>\n",r);
 ap_rprintf(r,"<FRAME NAME=f_value SCROLLING=no SRC='spreadsheet?editTop&par_area=sys&par_class=spreadsheet&par_id=%d'>\n",par_id);
 ap_rprintf(r,"<FRAME NAME=f_spreadsheet SRC='spreadsheet?editBottom&par_area=sys&par_class=spreadsheet&par_id=%d'>\n",par_id);
 ap_rputs("</FRAMESET>\n",r);
 
 return 0;
}

__CO_METHOD(co_editTop)

 __GET_INTEGER(par_id)
 
 FILE *fh;
 
 ap_rprintf(r,"<SCRIPT>var par_id=%d;</SCRIPT>\n",par_id);
 fh = ap_pfopen(r->pool,"/usr/local/apache/co_root/spreadsheet/editTop","r");

 ap_send_fd( fh, r );
 ap_pfclose(r->pool,fh);

 return 0;
}

__CO_METHOD(co_editBottom)

 __GET_INTEGER(par_id)
 
 int cols;
 int rows;
 int i,j,pos;
 FILE *fh;
 PGresult *res2;
 
 __INIT_VARIABLES

 ap_rprintf(r,"<HEAD>\n<SCRIPT>\nvar par_id=%d;\n</SCRIPT>\n",par_id);
 fh = ap_pfopen(r->pool,"/usr/local/apache/co_root/spreadsheet/editBottom.head","r");
 ap_send_fd( fh, r );
 ap_pfclose(r->pool,fh);
 ap_rputs("</HEAD>\n",r);
 fh = ap_pfopen(r->pool,"/usr/local/apache/co_root/spreadsheet/editBottom.body","r");
 ap_send_fd( fh, r );
 ap_pfclose(r->pool,fh);

// here we ought to generate spreadsheet

 ap_rprintf(r,"<TABLE id=tabela BORDER=5 COLS=%d",cols);
 ap_rputs(" LANGUAGE=javascript onkeyup='body_onkeyup()' onclick='return table_onclick()' ",r);
 ap_rputs(" ondblclick='table_ondblclick()' onmouseup='table_onmouseup()'",r);
 ap_rputs(" onselectstart='return table_onselectstart()' onmouseover='return table_onmouseover'",r);
 ap_rputs(" E_ONCLICK=0 E_ONDBLCLICK=0 E_ONAFTERUPDATE=0 E_ONADDCOLUMN=0 E_ONADDROW=0 E_ONBEFOREVALUECHANGE=0>\n",r);

// first row with column names ...

// obtain column ids
 sprintf(SQLString,"SELECT id FROM co_sys_spreadsheet_columns WHERE spreadsheet_id=%d ORDER BY column_number",par_id);

 __SQL_GET_RESULT
 cols = PQntuples(res);

 ap_rputs("<TR bgcolor=LightGrey align=center>\n<TD onclick='select_all()' id='ST'></TD>\n",r);
 for (i=1;i<=cols;i++) ap_rprintf(r,"<TD id=%d bgcolor=F0F0F0 style='font-family:verdana' align=center DB_ID=%s>%c</TD>\n",i,PQgetvalue(res,i-1,0),(char) (64+i));
 PQclear(res);

 ap_rputs("<TD bgcolor=black><INPUT type=button style='HEIGHT: 23px;WIDTH: 16px' value='+' onclick='add_column()'",r);
 ap_rputs(" id=button1 name=button1></TD>\n</TR>\n",r);

// read spreadsheet data from database

 sprintf(SQLString,"SELECT C.column_number,R.row_number,CL.value FROM ");
 sprintf(SQLString,"%sco_sys_spreadsheet_columns C, co_sys_spreadsheet_rows R, co_sys_spreadsheet_cells CL ",SQLString);
 sprintf(SQLString,"%sWHERE C.spreadsheet_id=%d AND C.spreadsheet_id=R.spreadsheet_id AND ",SQLString,par_id);
 sprintf(SQLString,"%sC.id=CL.column_id AND R.id=CL.row_id ",SQLString);
 sprintf(SQLString,"%sORDER BY R.row_number ASC, C.column_number ASC",SQLString);

 __SQL_GET_RESULT

// obtain row ids

 sprintf(SQLString,"SELECT id FROM co_sys_spreadsheet_rows WHERE spreadsheet_id=%d ORDER BY row_number",par_id);

 __SQL_GET_VRESULT(res2)
 rows = PQntuples(res2);

// translate data into HTML

 pos = 0;
 for (i=1;i<=rows;i++)
 {
  ap_rprintf(r,"<TR bgcolor=white bordercolor=MistyRose>\n<TD bgcolor=F0F0F0 style='font-family:verdana' id=%d DB_ID=%s>%d</TD>\n",i,PQgetvalue(res2,i-1,0),i);
  for (j=1;j<=cols;j++)
  {
   if (pos==PQntuples(res)) sprintf(JSOutBuf,".");
   else sprintf(JSOutBuf,((i==atoi(PQgetvalue(res,pos,1))) && (j==atoi(PQgetvalue(res,pos,0)))) ? ((char *) PQgetvalue(res,pos++,2)) : ".");
   ap_rprintf(r,"<TD TYP='STR'>%s</TD>\n",JSOutBuf);
  }
  ap_rputs("</TR>\n",r);
 }

 ap_rputs("<TR>\n<TD bgcolor=black><INPUT type=button value='+'",r);
 ap_rputs(" onclick='add_row()' id=button2 name=button2></TD>\n</TR>\n",r);
 ap_rputs("</TABLE>\n</BODY>",r);

 PQclear(res);
 PQclear(res2);

 return 0;
}
 
__CO_METHOD(co_create)

 __GET_INTEGER(par_id)
 __GET_INTEGER(cols)
 __GET_INTEGER(rows)
 
 int i;
 
 __INIT_VARIABLES

// create rows
 for (i=0;i<rows;i++)
 {
  sprintf(SQLString,"INSERT INTO co_sys_spreadsheet_rows(row_number,spreadsheet_id) VALUES(%d,%d)",i+1,par_id);
  __SQL_EXEC; 
 }
// create columns
 for (i=0;i<cols;i++)
 {
  sprintf(SQLString,"INSERT INTO co_sys_spreadsheet_columns(column_number,spreadsheet_id) VALUES(%d,%d)",i+1,par_id);
  __SQL_EXEC; 
 }

 return 0;
}

__CO_METHOD(co_hello)

 ap_rputs("hello world",r);
 return 0;
}

int column_number(PGconn *conn, int id)
{
 PGresult *res;
 char SQLString[SQLBUFSIZE];
 int Cols;

 sprintf(SQLString,"select MAX(column_number) from co_sys_spreadsheet_columns where spreadsheet_id=%d",id);

 __SQL_GET_RESULT
 Cols = atoi(PQgetvalue(res,0,0));
 
 PQclear(res);

 return Cols;
}

int row_number(PGconn *conn, int id)
{
 PGresult *res;
 char SQLString[SQLBUFSIZE];
 int rows;

 sprintf(SQLString,"select MAX(row_number) from co_sys_spreadsheet_rows where spreadsheet_id=%d",id);

 __SQL_GET_RESULT
 rows = atoi(PQgetvalue(res,0,0));
 
 PQclear(res);

 return rows;
}