//----- OBJECTS: menu, menu_item

var arrMenus = new Array();

//---------- MENU -------------

function menu(number, arg_par_class, arg_par_id, root_div, menu_name, menu_type, record_data)
{
	/* default arguments */
	if(menu.arguments.length<5) menu_name = "default";
	if(menu.arguments.length<6) menu_type = "single";
	if(menu.arguments.length<7) record_data = new Object();

	this.number = number;
	this.par_class = arg_par_class;
	this.par_id = arg_par_id;
	this.root_div = root_div;
	this.menu_items = new Array();
	this.menu_name = menu_name;
	this.menu_type = menu_type;
	this.record_data = record_data;

//  this.getParams = function() {getParamsFunction();};

	this.init();
};

function menu_init()
{
	var param = "menu?getByNameAllowedWithParents&";
	param += urlEncode("par_area", par_area);
	param += urlEncode("par_class", this.par_class);
	param += urlEncode("par_id", this.par_id);
	param += urlEncode("for_area", par_area);
	param += urlEncode("for_class", this.par_class);
	param += urlEncode("for_id", this.par_id);
	param += urlEncode("menu_name", this.menu_name);
	param += urlEncode("type", this.menu_type);
	var callback = "arrMenus["+this.number+"].show(";
	param += urlEncode("callback", callback);
	debugAlert(param);
	PutRequest(param,"sys");
};

function menu_show(o)
{
	if(typeof(o) == "object")
	{
		var div = this.root_div;
		clear(div);
		var tab = document.createElement("TABLE");
		tab.className = "menuTable";
		var tr=tab.insertRow(0);
		this.menu_items = new Array();
		for(var i=0; i<o.d["id"].length; i++)
		{
			var name =         o.d["name"][i];
			var display_name = o.d["display_name"][i];
			var graphical = true;
			var menu_params  = o.d["menu_params"][i];
			var id_menu_action =  o.d["id_menu_action"][i];
			var td = tr.insertCell(tr.cells.length);
			this.menu_items[i] = new menu_item(this, i, td, name, id_menu_action, display_name, menu_params, graphical);
		}
		div.appendChild(tab);
	}
}

function menu_refresh()
{
	for(var i=0; i<this.menu_items.length; i++)
	{
		this.menu_items[i].refresh();
	}
}

menu.prototype.init = menu_init;
menu.prototype.show = menu_show;
menu.prototype.refresh = menu_refresh;

//-------- MENU ITEM -----------
function createMenuParams(o, init_string, record_data)
{
  o["HIDDEN"]=null;
  o["COLSPAN"]=null;
  o["SIZE"]=null;
  o["REFRESH"]=null;
  o["DISPLAY_NAME"]=null;

  with(o)
  {
    eval(init_string);
  }
}

function menu_item_showTextMenu( arg_text )
{
	var t=document.createTextNode( arg_text );
	this.root_tag.className = "menuItemOff";
	this.root_tag.onmouseover = function() { this.className="menuItemOn"; };
	this.root_tag.onmouseout  = function() { this.className="menuItemOff"; }; 
	this.root_tag.appendChild(t);
}

function menu_item_showGraphicalMenu( arg_name )
{
	var img = document.createElement("IMG");
	img.className = "imageCatalogFunction";
	img.priv_name = arg_name;
	img.onmouseover= function() { this.src= image_path +  "buttons_on/"+this.priv_name +".gif"; };
	img.onmouseout = function() { this.src= image_path + "buttons_off/"+this.priv_name +".gif"; };
	img.src= image_path + "buttons_off/"+ img.priv_name +".gif"; 
	this.root_tag.appendChild(img);
}

function menu_item_refresh()
{
	this.params = new Object();
	createMenuParams(this.params, this.menu_params, this.par_menu.record_data);

//alert(objToString(this.params));
	if(!this.params.HIDDEN)
	{
		clear(this.root_tag);
		if(this.params.DISPLAY_NAME != null)
		{
			this.showTextMenu(this.params.DISPLAY_NAME);
		}
		else if (this.display_name != "")
		{
			this.showTextMenu(this.display_name);
		}
		else
		{
			this.showGraphicalMenu(this.name);
		}
	
		this.root_tag.priv_number = this.par_menu.number;
		this.root_tag.priv_menu_item = this.number;
		this.root_tag.priv_refresh = this.params.REFRESH;
		this.root_tag.onclick = function() {arrMenus[this.priv_number].menu_items[this.priv_menu_item].run(this.priv_refresh);};
	}
}

function menu_item(par_menu, num, root_tag, name, id_menu_action, display_name, menu_params, graphical)
{
	this.par_menu = par_menu;
	this.number = num;
	this.name = name;
	this.display_name = display_name;
	this.menu_params = menu_params;
	this.id_menu_action = id_menu_action;
	this.root_tag = root_tag;
	this.params = new Object();
	createMenuParams(this.params, this.menu_params, this.par_menu.record_data);
//    alert(""+this.name+"=>"+this.params["DISPLAY_NAME"]+"-->"+this.params["HIDDEN"]+"\n"+this.menu_params);

	this.refresh();
};

function menu_item_run(refresh)
{
	var param = "menu_action?run&";
//	param += urlEncode("par_area", par_area);
	param += urlEncode("par_class", "menu_action");
	param += urlEncode("par_id", this.id_menu_action);
	var add_param =  this.par_menu.getParams();
	if(refresh)
	{
		param += urlEncode("callback", 
		    "arrMenus["+this.par_menu.number+"].refresh(");
	}

//        alert(add_param);
	param += add_param;
//	alert(param);
	PutRequest(param,"sys");
};

menu_item.prototype.run = menu_item_run;
menu_item.prototype.refresh = menu_item_refresh;
menu_item.prototype.showTextMenu = menu_item_showTextMenu;
menu_item.prototype.showGraphicalMenu = menu_item_showGraphicalMenu;

//---------------END OF MENU Object



